 TRUE = 1
FALSE = 0

CONDITION_NOT_YET_MET = 0
CONDITION_SUCCEEDED = 1
CONDITION_FAILED = 2

MT_INFO = 0			-- large centre screen pop up
MT_ALERT = 1		-- top right alert message

MSG_TOP = 1
MSG_VCENTRE = 2
MSG_BOTTOM = 4
MSG_LEFT = 8
MSG_CENTRE = 16
MSG_RIGHT = 32

MSG_SMALL = 0
MSG_REG = 1
MSG_LRG = 2

gTrainSpeedLimitMPH = 101          -- speed at which warnings appear
gTrainSpeedLimitMPHDisplay = 100     -- speed limit of loco
gTrainSpeedLimitMPS = gTrainSpeedLimitMPH * 0.44704

gMaxPenaltyScore = 2000

gIsSpeeding = FALSE
gMaxWarnings = 5       -- number of warnings before brakes are applied
gMaxFiremanPanics = 5
gIsFiremanStopping = FALSE
gSpeedingScore = 0
gTimeSpentSpeeding = 0
gStartedSpeeding = 0
gNumSpeedings = 0
gNumFiremanPanics = 0
gTotalPenaltyScore = 0

gCurrentSpeed = 0

function OnEvent ( event )
	if (event == "Start") then
		SysCall ( "ScenarioManager:BeginConditionCheck", "SpeedCondition" );
		return TRUE;
	elseif (event == "Finish") then
		if ((gNumSpeedings == 0) and (gTotalPenaltyScore == 0)) then
			SysCall ( "ScenarioManager:TriggerScenarioComplete", "" );
		else
			local displaySpeedingTime = math.floor(gTimeSpentSpeeding)
			local displayPenalty = math.floor(gTotalPenaltyScore)
			
			SysCall ( "ScenarioManager:TriggerScenarioComplete", "" );
		end
	end
	
	return FALSE;
end

function TestCondition ( condition )
	if (condition == "SpeedCondition") then
		gCurrentSpeed = SysCall( "PlayerEngine:GetSpeed")
		if (gIsFiremanStopping == TRUE) then
			if (gCurrentSpeed < 0.1) then
				gIsFiremanStopping = FALSE
				gIsSpeeding = FALSE
				SysCall ( "ScenarioManager:ShowMessage", "Please remember the " .. gTrainSpeedLimitMPHDisplay .. "mph train speed limit for this train!" );
			else
				SysCall ( "PlayerEngine:SetControlValue", "Regulator", 0, 0.0);
				SysCall ( "PlayerEngine:SetControlValue", "Reverser", 0, 0.0);
				SysCall ( "PlayerEngine:SetControlValue", "TrainBrakeControl", 0, 1.0);
			end
		elseif (gCurrentSpeed > gTrainSpeedLimitMPS) then
			if (gIsSpeeding == FALSE) then
				SysCall( "ScenarioManager:ShowInfoMessageExt" ,  "Overspeed1.html", 5, MSG_LEFT + MSG_TOP, MSG_SMALL, FALSE )
				gStartedSpeeding = Call("*:GetSimulationTime", 0)
				gNumSpeedings = gNumSpeedings + 1
				gIsSpeeding = TRUE
				gIsFiremanStopping = FALSE
				gSpeedingScore = 0
			end
			
			gSpeedingScore = gSpeedingScore + (gCurrentSpeed - gTrainSpeedLimitMPS)
			gTotalPenaltyScore = gTotalPenaltyScore + (gCurrentSpeed - gTrainSpeedLimitMPS)
			
			if (gNumSpeedings > gMaxWarnings) then
				SysCall ( "ScenarioManager:ShowInfoMessageExt" ,  "Overspeed3.html", 10, MSG_CENTRE + MSG_VCENTRE, MSG_SMALL, FALSE );
				gIsFiremanStopping = FALSE
				SysCall ( "PlayerEngine:SetControlValue", "Regulator", 0, 0.0);
				SysCall ( "PlayerEngine:SetControlValue", "Reverser", 0, 0.0);
				SysCall ( "PlayerEngine:SetControlValue", "TrainBrakeControl", 0, 1.0);
			end
			
			if (gSpeedingScore > gMaxPenaltyScore) then
				gIsFiremanStopping = FALSE
				gNumFiremanPanics = gNumFiremanPanics + 1
				
				if (gNumFiremanPanics > gMaxFiremanPanics) then
					SysCall ("ScenarioManager:ShowInfoMessageExt" ,  "Overspeed2.html", 1, MSG_CENTRE + MSG_VCENTRE, MSG_REG, FALSE );
					gIsFiremanStopping = FALSE

				else
					SysCall ( );
				end
			end
			
		elseif (gIsSpeeding == TRUE) then
			gIsSpeeding = FALSE
			gIsFiremanStopping = FALSE
			
			local timeNow = Call("*:GetSimulationTime", 0)
			gTimeSpentSpeeding = gTimeSpentSpeeding + (timeNow - gTimeSpentSpeeding)
			
			gSpeedingScore = 0
		end
	
		return CONDITION_NOT_YET_MET;
	end
	
	return CONDITION_NOT_YET_MET;
end
